This patch adds an lstat() function to epic5.

Cobbled together by skullY@EFnet.

Index: functions.c
===================================================================
RCS file: /home/cvs/repository/epic5/source/functions.c,v
retrieving revision 1.290
diff -u -u -r1.290 functions.c
--- functions.c	29 Apr 2010 01:41:23 -0000	1.290
+++ functions.c	16 Jul 2010 10:23:47 -0000
@@ -310,6 +310,7 @@
 	*function_log10		(char *),
 	*function_logctl	(char *),
 	*function_longtoip	(char *),
+	*function_lstat		(char *),
 	*function_mask		(char *),
 	*function_maxlen	(char *),
 	*function_metric_time	(char *),
@@ -606,6 +607,7 @@
 	{ "LOG10",		function_log10		},
 	{ "LOGCTL",		function_logctl		}, /* logfiles.h */
 	{ "LONGTOIP",		function_longtoip	},
+	{ "LSTAT",		function_lstat		},
 	{ "MASK",		function_mask		},
 	{ "MATCH",		function_match 		},
 	{ "MATCHITEM",          function_matchitem 	},
@@ -5956,6 +5958,48 @@
 	return result;				/* DONT USE RETURN_STR HERE! */
 }
 
+BUILT_IN_FUNCTION(function_lstat, words)
+{
+	Filename expanded;
+	char *	filename;
+	char 	retval[BIG_BUFFER_SIZE];
+	Stat	sb;
+
+
+	if (!(filename = new_next_arg(words, &words)))
+		filename = words;
+
+	if (!filename || !*filename)
+		RETURN_INT(-1);
+
+	if (expand_twiddle(filename, expanded))
+		RETURN_INT(-1);
+
+	if (lstat(expanded, &sb) < 0)
+		RETURN_EMPTY;
+
+	snprintf(retval, BIG_BUFFER_SIZE,
+		"%d %d %o %d %d %d %d "
+		UINTMAX_FORMAT" "UINTMAX_FORMAT" "UINTMAX_FORMAT" "
+		INTMAX_FORMAT" "INTMAX_FORMAT" "INTMAX_FORMAT,
+		(int)	sb.st_dev,		/* device number */
+		(int)	sb.st_ino,		/* Inode number */
+		(int)	sb.st_mode,		/* Permissions */
+		(int)	sb.st_nlink,		/* Hard links */
+		(int)	sb.st_uid,		/* Owner UID */
+		(int)	sb.st_gid,		/* Owner GID */
+		(int)	sb.st_rdev,		/* Device type */
+		(uintmax_t)sb.st_size,		/* Size of file */
+		(uintmax_t)sb.st_blksize,	/* Size of each block */
+		(uintmax_t)sb.st_blocks,	/* Blocks used in file */
+		(intmax_t)sb.st_atime,		/* Last-access time */
+		(intmax_t)sb.st_mtime,		/* Last-modified time */
+		(intmax_t)sb.st_ctime		/* Last-change time */
+			);
+
+	RETURN_STR(retval);
+}
+
 BUILT_IN_FUNCTION(function_stat, words)
 {
 	Filename expanded;
